from .visualization_types import VisualizationType

# Visualization, how well does it support it, statistic, min, max
predicates = [
    (VisualizationType.NODE_LINK, 3, 'size', 0, 100),
    (VisualizationType.NODE_LINK, 2, 'size', 100, 1000),
    (VisualizationType.NODE_LINK, 1, 'size', 1000, 2000),
    (VisualizationType.NODE_LINK, 3, 'density', 0, 0.2),
    (VisualizationType.NODE_LINK, 1, 'density', 0.2, 1),
    (VisualizationType.NODE_LINK, 3, 'is_bipartite', 0.5, 1),
    (VisualizationType.NODE_LINK, 3, 'is_tree', 0.5, 1),
    (VisualizationType.NODE_LINK, 2, 'node_attributes', 0, 4),
    (VisualizationType.NODE_LINK, 1, 'node_attributes', 5, 100),
    (VisualizationType.NODE_LINK, 3, 'node_types', 0, 1),
    (VisualizationType.NODE_LINK, 2, 'node_types', 1, 10),
    (VisualizationType.NODE_LINK, 2, 'edge_attributes', 0, 2),
    (VisualizationType.NODE_LINK, 1, 'edge_attributes', 3, 100),
    (VisualizationType.NODE_LINK, 3, 'edge_types', 0, 1),
    (VisualizationType.NODE_LINK, 1, 'edge_types', 0, 1),

    (VisualizationType.SEMANTIC_SUBSTRATES, 3, 'size', 0, 100),
    (VisualizationType.SEMANTIC_SUBSTRATES, 1, 'size', 100, 1000),
    (VisualizationType.SEMANTIC_SUBSTRATES, 1, 'size', 1000, 2000),
    (VisualizationType.SEMANTIC_SUBSTRATES, 3, 'density', 0, 0.2),
    (VisualizationType.SEMANTIC_SUBSTRATES, 1, 'density', 0.2, 1),
    (VisualizationType.SEMANTIC_SUBSTRATES, 3, 'is_bipartite', 0.5, 1),
    (VisualizationType.SEMANTIC_SUBSTRATES, 1, 'is_tree', 0.5, 1),
    (VisualizationType.SEMANTIC_SUBSTRATES, 3, 'node_attributes', 0, 4),
    (VisualizationType.SEMANTIC_SUBSTRATES, 1, 'node_attributes', 5, 100),
    (VisualizationType.SEMANTIC_SUBSTRATES, 3, 'node_types', 0, 1),
    (VisualizationType.SEMANTIC_SUBSTRATES, 3, 'node_types', 1, 10),
    (VisualizationType.SEMANTIC_SUBSTRATES, 2, 'edge_attributes', 0, 2),
    (VisualizationType.SEMANTIC_SUBSTRATES, 1, 'edge_attributes', 3, 100),
    (VisualizationType.SEMANTIC_SUBSTRATES, 2, 'edge_types', 0, 1),
    (VisualizationType.SEMANTIC_SUBSTRATES, 1, 'edge_types', 0, 1),

    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 3, 'size', 0, 100),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'size', 100, 1000),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'size', 1000, 2000),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 3, 'density', 0, 0.2),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'density', 0.2, 1),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'is_bipartite', 0.5, 1),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'is_tree', 0.5, 1),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 3, 'node_attributes', 0, 4),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'node_attributes', 5, 100),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 3, 'node_types', 0, 1),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'node_types', 1, 10),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 2, 'edge_attributes', 0, 2),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'edge_attributes', 3, 100),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 2, 'edge_types', 0, 1),
    (VisualizationType.ATTRIBUTE_DRIVEN_NODELINK, 1, 'edge_types', 0, 1),

    (VisualizationType.ADJACENCY_MATRIX, 3, 'size', 0, 100),
    (VisualizationType.ADJACENCY_MATRIX, 1, 'size', 100, 1000),
    (VisualizationType.ADJACENCY_MATRIX, 1, 'size', 1000, 2000),
    (VisualizationType.ADJACENCY_MATRIX, 2, 'density', 0, 0.2),
    (VisualizationType.ADJACENCY_MATRIX, 3, 'density', 0.2, 1),
    (VisualizationType.ADJACENCY_MATRIX, 2, 'is_bipartite', 0.5, 1),
    (VisualizationType.ADJACENCY_MATRIX, 1, 'is_tree', 0.5, 1),
    (VisualizationType.ADJACENCY_MATRIX, 2, 'node_attributes', 0, 4),
    (VisualizationType.ADJACENCY_MATRIX, 3, 'node_attributes', 5, 100),
    (VisualizationType.ADJACENCY_MATRIX, 3, 'node_types', 0, 1),
    (VisualizationType.ADJACENCY_MATRIX, 2, 'node_types', 1, 10),
    (VisualizationType.ADJACENCY_MATRIX, 3, 'edge_attributes', 0, 2),
    (VisualizationType.ADJACENCY_MATRIX, 2, 'edge_attributes', 3, 100),
    (VisualizationType.ADJACENCY_MATRIX, 3, 'edge_types', 0, 1),
    (VisualizationType.ADJACENCY_MATRIX, 2, 'edge_types', 0, 1),

    (VisualizationType.QUILTS, 3, 'size', 0, 100),
    (VisualizationType.QUILTS, 1, 'size', 100, 1000),
    (VisualizationType.QUILTS, 1, 'size', 1000, 2000),
    (VisualizationType.QUILTS, 3, 'density', 0, 0.2),
    (VisualizationType.QUILTS, 1, 'density', 0.2, 1),
    (VisualizationType.QUILTS, 3, 'is_bipartite', 0.5, 1),
    (VisualizationType.QUILTS, 3, 'is_tree', 0.5, 1),
    (VisualizationType.QUILTS, 3, 'node_attributes', 0, 4),
    (VisualizationType.QUILTS, 3, 'node_attributes', 5, 100),
    (VisualizationType.QUILTS, 3, 'node_types', 0, 1),
    (VisualizationType.QUILTS, 3, 'node_types', 1, 10),
    (VisualizationType.QUILTS, 3, 'edge_attributes', 0, 2),
    (VisualizationType.QUILTS, 3, 'edge_attributes', 3, 100),
    (VisualizationType.QUILTS, 3, 'edge_types', 0, 1),
    (VisualizationType.QUILTS, 2, 'edge_types', 0, 1),

    (VisualizationType.BIOFABRIC, 3, 'size', 0, 100),
    (VisualizationType.BIOFABRIC, 1, 'size', 100, 1000),
    (VisualizationType.BIOFABRIC, 1, 'size', 1000, 2000),
    (VisualizationType.BIOFABRIC, 3, 'density', 0, 0.2),
    (VisualizationType.BIOFABRIC, 3, 'density', 0.2, 1),
    (VisualizationType.BIOFABRIC, 2, 'is_bipartite', 0.5, 1),
    (VisualizationType.BIOFABRIC, 1, 'is_tree', 0.5, 1),
    (VisualizationType.BIOFABRIC, 3, 'node_attributes', 0, 4),
    (VisualizationType.BIOFABRIC, 3, 'node_attributes', 5, 100),
    (VisualizationType.BIOFABRIC, 3, 'node_types', 0, 1),
    (VisualizationType.BIOFABRIC, 3, 'node_types', 1, 10),
    (VisualizationType.BIOFABRIC, 3, 'edge_attributes', 0, 2),
    (VisualizationType.BIOFABRIC, 3, 'edge_attributes', 3, 100),
    (VisualizationType.BIOFABRIC, 3, 'edge_types', 0, 1),
    (VisualizationType.BIOFABRIC, 3, 'edge_types', 0, 1),

    (VisualizationType.SUNBURST, 3, 'size', 0, 100),
    (VisualizationType.SUNBURST, 2, 'size', 100, 1000),
    (VisualizationType.SUNBURST, 1, 'size', 1000, 2000),
    (VisualizationType.SUNBURST, 0, 'density', 0, 0.2),
    (VisualizationType.SUNBURST, 0, 'density', 0.2, 1),
    (VisualizationType.SUNBURST, 0, 'is_bipartite', 0.5, 1),
    (VisualizationType.SUNBURST, 3, 'is_tree', 0.5, 1),
    (VisualizationType.SUNBURST, 3, 'node_attributes', 0, 4),
    (VisualizationType.SUNBURST, 1, 'node_attributes', 5, 100),
    (VisualizationType.SUNBURST, 3, 'node_types', 0, 1),
    (VisualizationType.SUNBURST, 1, 'node_types', 1, 10),
    (VisualizationType.SUNBURST, 0, 'edge_attributes', 0, 2),
    (VisualizationType.SUNBURST, 0, 'edge_attributes', 3, 100),
    (VisualizationType.SUNBURST, 0, 'edge_types', 0, 1),
    (VisualizationType.SUNBURST, 0, 'edge_types', 0, 1),

    (VisualizationType.TREEMAP, 3, 'size', 0, 100),
    (VisualizationType.TREEMAP, 2, 'size', 100, 1000),
    (VisualizationType.TREEMAP, 2, 'size', 1000, 2000),
    (VisualizationType.TREEMAP, 0, 'density', 0, 0.2),
    (VisualizationType.TREEMAP, 0, 'density', 0.2, 1),
    (VisualizationType.TREEMAP, 0, 'is_bipartite', 0.5, 1),
    (VisualizationType.TREEMAP, 3, 'is_tree', 0.5, 1),
    (VisualizationType.TREEMAP, 3, 'node_attributes', 0, 4),
    (VisualizationType.TREEMAP, 1, 'node_attributes', 5, 100),
    (VisualizationType.TREEMAP, 3, 'node_types', 0, 1),
    (VisualizationType.TREEMAP, 1, 'node_types', 1, 10),
    (VisualizationType.TREEMAP, 0, 'edge_attributes', 0, 2),
    (VisualizationType.TREEMAP, 0, 'edge_attributes', 3, 100),
    (VisualizationType.TREEMAP, 0, 'edge_types', 0, 1),
    (VisualizationType.TREEMAP, 0, 'edge_types', 0, 1),
]